/**************************************************************************/
/*                                                                        */
/*  Thibaut Balabonski, Sylvain Conchon, Jean-Christophe Filliâtre,       */
/*  Kim Nguyen, Laurent Sartre                                            */
/*                                                                        */
/*  Informatique - MP2I/MPI - CPGE 1re et 2e années.                      */
/*  Cours et exercices corrigés. Éditions Ellipses, 2022.                 */
/*                                                                        */
/*  https://www.informatique-mpi.fr/                                      */
/*                                                                        */
/**************************************************************************/

// composantes fortement connexes d'un graphe orienté
// algorithme de Kosaraju--Sharir

#include "prelude.h"
#include "digraph.h"

#ifndef KOSARAJU_SHARIR
#define KOSARAJU_SHARIR

int kosaraju_sharir(digraph *g, int num[]);
// remplit le tableau num avec le numéro de la composante de chaque sommet
// (suppose num de taille digraph_size(g))
// renvoie le nombre de composantes

#endif
